diff --git a/lisp/wid-edit.el b/lisp/wid-edit.el
index 284fd1d6cb..62a6079637 100644
--- a/lisp/wid-edit.el
+++ b/lisp/wid-edit.el
@@ -603,6 +603,11 @@ widget-image-conversion
 		       (repeat :tag "Suffixes"
 			       (string :format "%v")))))
 
+(defcustom widget-high-res-icon t
+  "If non-nil, Emacs tries to use high resolution icons in widgets."
+  :group 'widgets
+  :type 'boolean)
+
 (defun widget-image-find (image)
   "Create a graphical button from IMAGE.
 IMAGE should either already be an image, or be a file name sans
@@ -619,6 +624,13 @@ widget-image-find
 	 ;; A string.  Look it up in relevant directories.
 	 (let* ((load-path (cons widget-image-directory load-path))
 		specs)
+           (if widget-high-res-icon
+               (dolist (elt widget-image-conversion)
+	         (dolist (ext (cdr elt))
+	           (push (list :type (car elt)
+                               :file (concat image "@2x" ext)
+                               :scale 0.5)
+                         specs))))
 	   (dolist (elt widget-image-conversion)
 	     (dolist (ext (cdr elt))
 	       (push (list :type (car elt) :file (concat image ext))
